<?php
/***************************************************************************
 *                              forum_tour.php
 *                            -------------------
 *   copyright            : (C) 2004 OXPUS
 *   email                : administrator@oxpus.de
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

// Define page is using in phpBB
define('IN_PHPBB', true);

// Include required files
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);
include($phpbb_root_path . 'includes/functions_post.'.$phpEx);
include($phpbb_root_path . 'includes/bbcode.'.$phpEx);

//
// Start session management
$userdata = session_pagestart($user_ip, PAGE_FORUM_TOUR);
init_userprefs($userdata);


include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_tour.' . $phpEx);

//
// Set variables on default values
$page_subject = '';
$page_text = '';
$page_bbcode_uid = '';
$page_sort = '';
$pagination = '';
$first_page = '';

//
// Load templates
$page_title = $lang['Forum_tour'];
$gen_simple_header = TRUE;
include($phpbb_root_path . 'includes/page_header.'.$phpEx);

$template->set_filenames(array(
	'body' => 'tour_body.tpl')
);

//
// Get currect page number
$start = 0;
$page = ( $HTTP_POST_VARS['page'] ) ? $HTTP_POST_VARS['page'] : $HTTP_GET_VARS['page'];
$page = ( !$page ) ? $start : $page;

//
// Check for content
$sql = "SELECT count(page_subject) as max_page FROM " . FORUM_TOUR_TABLE;
if ( !($result = $db->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, "Could not obtain forum tour data.", '', __LINE__, __FILE__, $sql);
}

while ($row = $db->sql_fetchrow($result))
{
	$max_page = $row['max_page'];
}

if ( $max_page != 0 )
{
	$page_count = $max_page;
	$max_page++;
	//
	// Create forum tour
	if ( $page == 0 )
	{
		//
		// Create first page per default or on demand
		$sql = "SELECT page_subject, page_sort FROM " . FORUM_TOUR_TABLE . "
			ORDER BY page_sort";
		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, "Could not obtain forum tour.", '', __LINE__, __FILE__, $sql);
		}

		while ($row = $db->sql_fetchrow($result))
		{
			$first_page .= ( $first_page != '' ) ? '<br /><br /><a href="'.append_sid("tour.$phpEx?page=".$row['page_sort']).'" class=mainmenu>'.$row['page_subject'].'</a>' : '<a href="'.append_sid("tour.$phpEx?page=".$row['page_sort']).'" class=mainmenu>'.$row['page_subject'].'</a>';
		}

		$page_subject = $lang['First_page'];
		$page_text = $first_page;
		$page_bbcode_uid = '';
		$page_sort = 0;
	}
	else
	{
		//
		// Get another page
		$sql = "SELECT * FROM " . FORUM_TOUR_TABLE . "
			WHERE page_sort = $page";
		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, "Could not obtain forum tour.", '', __LINE__, __FILE__, $sql);
		}

		while ($row = $db->sql_fetchrow($result))
		{
			$page_subject = $row['page_subject'];
			$page_text = $row['page_text'];
			$page_bbcode_uid = $row['bbcode_uid'];
			$page_sort = $row['page_sort'];
		}
	}

	//
	// Get pagination
	for ( $i = 1; $i < $max_page; $i++ )
	{
		$tour_page = $i * 10;
		$tour_page = ( $tour_page != $page ) ? '<a href="'.append_sid("tour.$phpEx?page=$tour_page").'" class="nav">'.$i.'</a>' : $i;
		$pagination .= ( $pagination == '' ) ? ' '.$tour_page : ', '.$tour_page;
	}

	$prev_page = ( $page != 10 && $page != 0 ) ? '<input type="submit" name="page" value="'.$lang['Previous'].'" onClick="javascript:tour(\''.append_sid("tour.$phpEx?page=".($page - 10)).'\')">' : '<input type="submit" name="page" value="'.$lang['Previous'].'" disabled="disabled">';
	$next_page = ( ($page / 10) != ($max_page - 1) ) ? '<input type="submit" name="page" value="'.$lang['Next'].'" onClick="javascript:tour(\''.append_sid("tour.$phpEx?page=".($page + 10)).'\')">' : '<input type="submit" name="page" value="'.$lang['Next'].'" disabled="disabled">';
	$page_one = ( $page != 0 ) ? '<input type="submit" name="page" value="'.$lang['First_page'].'" onClick="javascript:tour(\''.append_sid("tour.$phpEx?page=0").'\')">' : '<input type="submit" name="page" value="'.$lang['First_page'].'" disabled="disabled">';

	$pagination = ( ( $page != 0 && $page_count != 1 ) ? '<br /><br />' . $lang['Tour_page'] . $pagination : '' );

	//
	// Prepare the currect page for output
	$subject = stripslashes($page_subject);
	$message = stripslashes($page_text);
	$bbcode_uid = $page_bbcode_uid;

	$message = bbencode_second_pass($message, $bbcode_uid);
	$message = smilies_pass($message);

	$message = str_replace("\n", "\n<br />\n", $message);

	//
	// Pull the page to the template
	$template->assign_block_vars('forum_tour', array(
		'SUBJECT' => $subject,
		'MESSAGE' => $message,
		'PAGINATION' => $pagination,
		'NAV_PREV' => $prev_page,
		'NAV_NEXT' => $next_page,
		'NAV_FIRST_PAGE' => $page_one)
	);
}
else
{
	$template->assign_block_vars('switch_no_forum_tour', array(
		'L_NO_FORUM_TOUR' => $lang['No_forum_tour'])
	);
}

//
// Pull global values to template
$template->assign_vars(array(
	'L_CLOSE_TOUR' => $lang['Tour_close'])
);

//
// Create the current page
$template->pparse('body');

//
// Include the forum footer
include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

?>
